﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
	import flash.display.BitmapData;
	import flash.geom.Point;
	
    public class PlayState extends FlxState
    {

		static public var lyrTree:FlxLayer;
		static public var lyrHUD:FlxLayer;
		
		public static var _lblLevelTitle:FlxText;
		private var _lblVersion:FlxText;
		private var _lblDate:FlxText;
		private var _lblMerges:FlxText;
		private var _dateFlt:Number;
		public static var _dateInt:int;
		private var _mergesInt:int;
		
		static public var editmode:Boolean;
		static public var mouseup:Boolean;
		
		static public var t:Tree;
		static public var ta:Array;
		static public var minorversion:int;
		
		static private function genTree(a:Array):void
		{
			var arr:Array = duplicate(a);
			
			t = new Tree(a);
			var xoffset:Number;
			var yoffset:Number;
			xoffset = (FlxG.width - t.width()) / 2;
			trace(t.root.generation);
			yoffset = (FlxG.height - TreeNode.height * (t.root.generation + 1) - TreeNode.marginy * (t.root.generation)) / 2-10;
			
			if (t.width() + 20 > FlxG.width || t.root.generation>7)
			{
				//invalid.  Just revert.
				a = duplicate(ta);
				t = new Tree(a);
				xoffset = (FlxG.width - t.width()) / 2;
				yoffset = (FlxG.height - TreeNode.height * (t.root.generation + 1) - TreeNode.marginy * (t.root.generation))/2-10;
			}
			
			t.offset(new Point(int(xoffset), -int(yoffset)));
			
			
			lyrTree.destroy();
						
			var sprites:FlxArray = t.getSprites();			
			for (var i:int = 0; i < sprites.length; i++)
			{
				lyrTree.add(sprites[i]);
			}
			
			var buttons:FlxArray = t.getButtons();
			for (i = 0; i < buttons.length; i++)
			{
				lyrTree.add(buttons[i]);
			}
			
			ta = duplicate(a);
		}
		
		static public function duplicate(a:Array):Array
		{
			var arr:Array=new Array;
			if (a == null)
				return null;
				
			for (var i:int = 0; i < a.length; i++)
			{
				arr.push(duplicate(a[i]));
			}
			return arr;
		}
		static public function AddNew(index:Vector.<int>):void
		{
			
			var arr:Vector.<int> = index.concat();
			var curroot:Array = duplicate(ta);
			var cur:Array = curroot;
			var prevcur:Array = null;
			for (var i:int = 0; i < arr.length; i++)
			{
				prevcur = cur;
				cur = cur[arr[i]];
			}	
			if (prevcur && prevcur.length == 1)
				return;
			cur.push([]);
			genTree(curroot);
		}
		
		static public function AddRand(n:int = 1):void
		{			
			for (var i:int = 0; i < n; i++)
			{
				var curroot:Array = duplicate(ta);
				var prevcur:Array = curroot;
				var cur:Array = curroot;
				
				while(true)
				{
					prevcur = cur;
					if (cur.length == 1)
					{
						cur = prevcur;
						break;
					}
					if (Math.random() > 0.2)
					{
						var a:Array = cur[int(Math.random() * cur.length)];
						if (a == null)
							break;
						else
							cur = a;
					}
					else
						break;
				}	
				cur.push([]);
				genTree(curroot);
			}
		}
		
        public function PlayState():void
        {
			PlayState.minorversion = 0;
			this._dateFlt = 0;
			_dateInt = 0;
			editmode = false;
            super();
			FlxG.setCursor(MenuState.GfxCursor);
			
			lyrTree = new FlxLayer;			
			lyrHUD = new FlxLayer;
			
			PlayState._lblLevelTitle = new FlxText(3, 1, FlxG.width-3, 30, "We give you the right tools to manage your development.", 0xffffff00, null, 8, "left");
			_lblLevelTitle.setText("We give you the right tools to manage your development.", true);
			this._lblDate = new FlxText(FlxG.width-500, FlxG.height-24, 500, 10, "Week: 1", 0xffffff00, null, 8, "right");
			this._lblMerges = new FlxText(FlxG.width-500, FlxG.height-12, 500, 10, "Merges: 0", 0xffffff00, null, 8, "right");
			this._lblVersion = new FlxText(3, FlxG.height-12, 500, 10, "Version 0.2", 0xffffff00, null, 8, "left");
			
			lyrHUD.add(PlayState._lblLevelTitle);
			lyrHUD.add(this._lblDate);
			lyrHUD.add(this._lblMerges);
			lyrHUD.add(this._lblVersion);
			
			this.add(lyrTree);
			this.add(lyrHUD);
			
			var bd1:BitmapData;
			var bd2:BitmapData;

			bd1 = new BitmapData(40, 10,false, 0xff0050a4);
			bd2 = new BitmapData(40, 10,false, 0xff0050a4);
				
			for (var i:int = 0; i < TreeNode.width; i++)
			{
				for (var j:int = 0; j < TreeNode.height; j++)
				{
					if (i == 0 || j == 0 || i == 39 || j == 9)
					{
						if (int(i+j)%2==0)
						bd1.setPixel(i, j, 0xffffff00);
						bd2.setPixel(i, j, 0xffffff00);
					}
				}
			}
			
			var s1:FlxSprite = new FlxSprite(null, 0, 0, false, false, 40, 10, 0xff0050a4);
			s1.pixels = bd1;
			s1.update();
			
			var s2:FlxSprite = new FlxSprite(null, 0, 0, false,false, 40, 10, 0xff0050a4);
			s2.pixels = bd2;
			s2.update();
									
			const n:Array = [];
			
			/*ta = [
					n,
					n,
					[n,[n,n],n],
					n,
					n,
					[n,n],
						[
							n, 
								[
									n, 
										[
											n, 
											n, 
											n
										], 
									n
								]
						],
					n, 
					[n,n]
				];*/
			//a = [n,n,n];
			//a = [n, [n], n];
			ta = [];
			genTree(ta);
        }
        
        override public function update():void
        {			
			super.update();

			updateDate(); 
			updateMerges();
			
			if (FlxG.justPressed(FlxG.A))
			{
				//PlayState.AddRand();
			}
			if (!FlxG.kMouse)
				mouseup = true;
				
			for (var i:int = 0; i < t.nodes.length; i++)
			{
				t.nodes[i].update();
			}
			
			if (PlayState.t.root.capDisplay != PlayState.minorversion)
			{
				PlayState.minorversion = PlayState.t.root.capDisplay;
				this._lblVersion.setText("Version " + (FlxG.level).toString() + "." + minorversion.toString());
				
			}
		}		
		
		public static function nextlevel():void
		{
			FlxG.level++;
			FlxG.play(MenuState.SndLevel);
			switch(FlxG.level)
			{
				case 1:
				AddRand(2);
				PlayState._lblLevelTitle.setText("Just click to merge branches: it's so easy!");
				PlayState.t.root.capacity= 10 * (2*FlxG.level);
				break;
				case 2:
				AddRand(2);
				PlayState._lblLevelTitle.setText("Our solutions are designed to scale as your product grows.");
				PlayState.t.root.capacity= 10 * (2*FlxG.level);
				break;
				case 3:
				AddRand(2);
				PlayState._lblLevelTitle.setText("We have an array of training courses to meet your needs.");
				PlayState.t.root.capacity= 10 * (2*FlxG.level);
				break;
				case 4:
				AddRand(2);
				PlayState._lblLevelTitle.setText("Call us for an estimate on our latest solutions.");
				PlayState.t.root.capacity= 10 * (2*FlxG.level);
				break;
				case 5:
				AddRand(2);
				PlayState._lblLevelTitle.setText("Servers running slowly? Time for an upgrade!");
				PlayState.t.root.capacity= 10 * (2*FlxG.level);
				break;
				case 6:
				AddRand(2);
				PlayState._lblLevelTitle.setText("We're here to solve your problems.");
				PlayState.t.root.capacity= 10 * (2*FlxG.level);
				break;
				case 7:
				AddRand(2);
				PlayState._lblLevelTitle.setText("Thank you for upgrading to our enterprise package.");
				PlayState.t.root.capacity= 10 * (2*FlxG.level);
				break;
				case 8:
				AddRand(2);
				PlayState._lblLevelTitle.setText("There are many expert consultants who can assist your.");
				PlayState.t.root.capacity= 10 * (2*FlxG.level);
				break;
				case 9:
				AddRand(2);
				PlayState._lblLevelTitle.setText("Our solutions are employed by hundreds of businesses.");
				PlayState.t.root.capacity= 10 * (2*FlxG.level);
				break;
				case 10:
				AddRand(2)
				PlayState._lblLevelTitle.setText("Thank you for using our award winning business solutions.");
				PlayState.t.root.capacity= 10 * (2*FlxG.level);
				break;		
				case 11:
				FlxG.switchState(EndState);
				break;
			}
		}
		
		private function updateDate():void
		{
			this._dateFlt += FlxG.elapsed;
			var n:int = int(this._dateFlt / 6)+1;
			if (n != _dateInt)
			{
				_dateInt = n;
				FlxG.play(MenuState.SndWeek);
				this._lblDate.setText("Week " + n.toString());
				trace(n);
			}
		}
		
		private function updateMerges():void
		{
			if (this._mergesInt != FlxG.merges)
			{
				this._mergesInt = FlxG.merges;
				_lblMerges.setText("Merges: " + _mergesInt.toString());				
			}
		}
    }    
}