﻿package com.Tutorial 
{
	import com.adamatomic.flixel.*;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	/**
	 * ...
	 * @author Stephen Lavelle
	 */
	public class TreeNode
	{
		public var capacity:Number;
		public var capDisplay:int;
		public var amount:Number;
		public var rate:Number;
		public var prog:int;
		public var colour:String;
		public var mergingdown:Boolean;
		public var targeted:Boolean;
		
		static public const width:int = 9;
		static public const height:int = 9;
		static public const marginx:int = 5;
		static public const marginy:int = 7;

		public var parent:TreeNode;
		public var children:Vector.<TreeNode>;
		public var connectors:Vector.<Connector>;
		public var connectionTo:Vector.< Vector.<Connector> >;
		public var location:Vector.<int>;
		
		public var offset:Point;
		public var rightmost:Number;
		public var generation:int;		
		
		public var sprite:FlxSprite;
		public var counters:FlxSprite;
		public var button:FlxButton;
		
		static public var sprBitmapData:BitmapData;
		static public var buttonoverdata:BitmapData;
		static public var cntBitmapData:BitmapData;
		
		public function TreeNode(a:Array,p:TreeNode,xoffset:Number,yoffset:Number,loc:Vector.<int>) 
		{
			colour = "y";
			children = new Vector.<TreeNode>;
			rate = 2 + Math.random()/10;
			amount = 0;
			targeted = false;
			if (loc == null)
			{
				location = new Vector.<int>;
			}
			else
			{
				location = loc.concat();
			}
			
			offset = new Point(int(xoffset),int(yoffset));
			rightmost = xoffset;
			
			parent = p;
			// add children
			for (var i:int = 0; i < a.length; i++)
			{
				if (i > 0)
					rightmost += width + marginx;
				var v:Vector.<int> = location.concat();
				v.push(i);
				var c:TreeNode = 
					new TreeNode(a[i], this, rightmost,yoffset-height-marginy,v);
				children.push(c);
				
				rightmost = children[children.length - 1].rightmost;
			}
			
			if (children.length > 0)
			{
				offset.x = int(
					((children[0].offset.x + width / 2) + (children[children.length - 1].offset.x + width / 2)) / 2 - width / 2);
				
				for (i = 0; i < children.length;i++)
				{
					generation = Math.max(generation, children[i].generation+1);
				}
			}
			
			capacity = 10 * (Math.pow(2,generation));

						
			if (sprBitmapData == null)
			{
				sprBitmapData = new BitmapData(TreeNode.width * 4, TreeNode.height, false, 0xff0050a4);
				
				for (i = 0; i < TreeNode.width; i++)
				{
					for (j = 0; j < TreeNode.height; j++)
					{
						if (i == 0 || j == 0 || i == TreeNode.width - 1 || j == TreeNode.height - 1)
						{
							sprBitmapData.setPixel(i, j, 0xffffff00);
							sprBitmapData.setPixel(TreeNode.width + i, j, 0xffff0000);
							if (int(i+j)%2==0)
							{	
								sprBitmapData.setPixel(TreeNode.width*2 + i, j, 0xffff0000);
							}
							else
							{
								sprBitmapData.setPixel(TreeNode.width*2 + i, j, 0xffffff00);								
							}
						}
					}
				}
			}
			if (cntBitmapData == null)
			{
				cntBitmapData = new BitmapData((TreeNode.width-4) * (18+1), (TreeNode.height-4), false, 0xff0050a4);
				
				for (i = 1; i <=9 ; i++)
				{
					if (i < 1)
						continue;
					cntBitmapData.setPixel((TreeNode.width - 4) * i + 0, 4, 0xffffff00);
					cntBitmapData.setPixel((TreeNode.width-4)*9+(TreeNode.width-4)*i+0, 4, 0xffffff00);

					if (i < 2)
						continue;
					cntBitmapData.setPixel((TreeNode.width - 4) * i + 2, 4, 0xffffff00);
					cntBitmapData.setPixel((TreeNode.width - 4) * 9 + (TreeNode.width - 4) * i + 2, 4, 0xffffff00);
					
					if (i < 3)
						continue;
					cntBitmapData.setPixel((TreeNode.width-4)*i+4, 4, 0xffffff00);
					cntBitmapData.setPixel((TreeNode.width - 4) * 9 + (TreeNode.width - 4) * i + 4, 4, 0xffffff00);
					
					if (i < 4)
						continue;
					cntBitmapData.setPixel((TreeNode.width-4)*i+4, 2, 0xffffff00);
					cntBitmapData.setPixel((TreeNode.width - 4) * 9 + (TreeNode.width - 4) * i + 4, 2, 0xffffff00);
					
					if (i < 5)
						continue;
					cntBitmapData.setPixel((TreeNode.width-4)*i+2, 2, 0xffffff00);
					cntBitmapData.setPixel((TreeNode.width - 4) * 9 + (TreeNode.width - 4) * i + 2, 2, 0xffffff00);
					
					if (i < 6)
						continue;
					cntBitmapData.setPixel((TreeNode.width-4)*i+0, 2, 0xffffff00);
					cntBitmapData.setPixel((TreeNode.width - 4) * 9 + (TreeNode.width - 4) * i + 0, 2, 0xffffff00);
					
					if (i < 7)
						continue;
					cntBitmapData.setPixel((TreeNode.width-4)*i+0, 0, 0xffffff00);
					cntBitmapData.setPixel((TreeNode.width - 4) * 9 + (TreeNode.width - 4) * i + 0, 0, 0xffffff00);
					
					if (i < 8)
						continue;
					cntBitmapData.setPixel((TreeNode.width-4)*i+2, 0, 0xffffff00);
					cntBitmapData.setPixel((TreeNode.width-4)*9+(TreeNode.width-4)*i+2, 0, 0xffffff00);
					
					if (i < 9)
						continue;
					cntBitmapData.setPixel((TreeNode.width - 4) * i + 4, 0, 0xffffff00);
					cntBitmapData.setPixel((TreeNode.width-4)*9+(TreeNode.width-4)*i+4, 0, 0xffffff00);					
				}
			}
			
			counters = new FlxSprite(null, offset.x + 2, offset.y + 2, false, false, TreeNode.width - 4, TreeNode.height - 4, 0xff00ffff);
			counters.pixels = cntBitmapData;
			counters.update();
			counters.addAnimation("y0", [0], 0, false);
			counters.addAnimation("y1", [1], 0, false);
			counters.addAnimation("y2", [2], 0, false);
			counters.addAnimation("y3", [3], 0, false);
			counters.addAnimation("y4", [4], 0, false);
			counters.addAnimation("y5", [5], 0, false);
			counters.addAnimation("y6", [6], 0, false);
			counters.addAnimation("y7", [7], 0, false);
			counters.addAnimation("y8", [8], 0, false);
			counters.addAnimation("y9", [9], 0, false);
			counters.addAnimation("r0", [0], 0, false);
			counters.addAnimation("r1", [10], 0, false);
			counters.addAnimation("r2", [11], 0, false);
			counters.addAnimation("r3", [12], 0, false);
			counters.addAnimation("r4", [13], 0, false);
			counters.addAnimation("r5", [14], 0, false);
			counters.addAnimation("r6", [15], 0, false);
			counters.addAnimation("r7", [16], 0, false);
			counters.addAnimation("r8", [17], 0, false);
			counters.addAnimation("r9", [18], 0, false);
			counters.play("y0");
			
			sprite = new FlxSprite(null, offset.x, offset.y, true, false, width, height, 0xff00ffff);
			sprite.pixels = sprBitmapData;
			sprite.update();
			sprite.addAnimation("y", [0], 0, false);
			sprite.addAnimation("r", [1], 0, false);
			sprite.addAnimation("yb", [0,3], 2.2,true);
			sprite.addAnimation("rb", [1,3], 2.2, true);
			sprite.addAnimation("b", [2, 3], 1.9, true);
			/*switch(int(Math.random() * 5))
			{
				case 0:
					sprite.play("yellow", true);
					break;
				case 1:
					sprite.play("red", true);
					break;
				case 2:
					sprite.play("yellowblocked", true);
					break;
				case 3:
					sprite.play("redblocked", true);
					break;
				case 4:
					sprite.play("waitblocked", true);
					break;
			}*/
			sprite.play("y", true);

			if (buttonoverdata == null)
			{
				buttonoverdata = new BitmapData(TreeNode.width + 4, TreeNode.height + 4,true,0xff000000);
				for (i = 0; i < TreeNode.height + 4; i++)
				{
					for (j = 0; j < TreeNode.height + 4; j++)
					{
						buttonoverdata.setPixel(i, j, 0xffffff00);
					}
				}
			}
			var s:FlxSprite = new FlxSprite(buttonoverdata as Class, 20, 20, false,false, TreeNode.width + 4, TreeNode.height + 4);
			
			if (this.parent != null)
			{
				button = 
					new FlxButton(offset.x-2, offset.y-2, new FlxSprite(null,0,0,false,false,TreeNode.width+4,TreeNode.height+4),onClick,new FlxSprite(null,0,0,false,false,TreeNode.width+4,TreeNode.height+4,0x5fffff00));
				button.update();
			}
			
			connectors = new Vector.<Connector>;
			connectionTo = new Vector.< Vector.<Connector> >;
				
			if (children.length > 0)
			{	
				var baseNub:Connector = new Connector(offset.x + width / 2, offset.y - 3, 1, 3);
				connectors.push(baseNub);
				
				var baseNubTip:Connector = new Connector(offset.x + width / 2, offset.y - 4, 1, 1);
				connectors.push(baseNubTip);

				var downNubs:Vector.<Connector>;
				downNubs = new Vector.<Connector>;
				
				var hConnectors:Vector.<Connector>;
				hConnectors = new Vector.<Connector>;

				for (i = 0; i < children.length; i++)
				{			
					var downNub:Connector = new Connector(children[i].offset.x + width / 2, children[i].offset.y + TreeNode.height, 1, 3);
					connectors.push(downNub);
					downNubs.push(downNub);
		
					var pointNub:Connector = new Connector(children[i].offset.x + width / 2, children[i].offset.y + TreeNode.height + 3, 1, 1);
					connectors.push(pointNub);
					hConnectors.push(pointNub);
				}
				
				//do horizontal slots now
				for (i = 0; i < children.length - 1; i++)
				{
					if (this.offset.x >= children[i].offset.x && this.offset.x <= children[i+1].offset.x)
					{
						if ( this.offset.x - children[i].offset.x - 1 > 0)
						{
							var transConnectors1:Connector = new Connector(children[i].offset.x + width / 2 + 1, children[i].offset.y + TreeNode.height + 3, this.offset.x - children[i].offset.x - 1, 1);
							if (transConnectors1)
							{
								connectors.push(transConnectors1);
								hConnectors.push(transConnectors1);						
							}
						}

						if ( children[i + 1].offset.x - this.offset.x - 1 > 0)
						{
							var transConnectors2:Connector = new Connector(this.offset.x + width / 2 + 1, children[i].offset.y + TreeNode.height + 3, children[i + 1].offset.x - this.offset.x - 1, 1);
							if (transConnectors2)
							{
								connectors.push(transConnectors2);
								hConnectors.push(transConnectors2);						
							}	
						}
					}
					else
					{
						if ( children[i + 1].offset.x - children[i].offset.x - 1 )
						{
							var transConnector:Connector = new Connector(children[i].offset.x + width / 2 + 1, children[i].offset.y + TreeNode.height + 3, children[i + 1].offset.x - children[i].offset.x - 1, 1);
							if (transConnector)
							{
								connectors.push(transConnector);
								hConnectors.push(transConnector);						
							}
						}
					}
				}
				
				for (i = 0; i < children.length; i++)
				{
					var connection:Vector.<Connector>;
					connection = new Vector.<Connector>;
					connection.push(baseNub);
					connection.push(downNubs[i]);
					
					for (var j:int = 0; j < hConnectors.length; j++)
					{
						var x1:Number;
						var x2:Number;
						
						x1 = children[i].sprite.x;
						x2 = this.sprite.x;
						
						if (x1 > x2)
						{
							var t:Number = x1;
							x1 = x2;
							x2 = t;
						}
						
						x1 += TreeNode.width / 2 - 2;
						x2 += TreeNode.width / 2 + 2;
							
						if ( (x1 <= hConnectors[j].x) && (hConnectors[j].x + hConnectors[j].width <= x2) )
						{
							connection.push(hConnectors[j]);
						}
					}
					
					connectionTo.push(connection);
				}
			}
		}
		
		public function getNodes():Vector.<TreeNode>
		{
			var a:Vector.<TreeNode> = new Vector.<TreeNode>;
			a.push(this);
			for (var i:int = 0; i < children.length; i++)
			{
				a = a.concat(children[i].getNodes());
			}
			return a;
		}
		
		public function update():void
		{
			if (PlayState.editmode)
				return;
			var updateDisplay:Boolean = false;
			if (this.mergingdown)
			{
				var finished:Boolean = false;
				var delta:Number = 5 * rate * FlxG.elapsed;
				if (delta >= this.amount)
				{
					delta = this.amount;
					finished = true;
				}
				
				if (this.parent.capacity - this.parent.amount >= delta)
				{
					
				}
				else
				{
					delta = this.parent.capacity - this.parent.amount;
					finished = true;
				}
				
				this.parent.amount += delta;
				this.amount -= delta;	
				updateCounts();
				this.parent.updateCounts();
				
				if (finished)
				{
					var index:int = this.parent.children.indexOf(this);	
					var conns:Vector.<Connector> = this.parent.connectionTo[index];
					for (var i:int = 0; i < conns.length; i++)
					{
						conns[i].play(this.colour.toString(),true);
					}
					this.parent.targeted = false;
					this.mergingdown = false;
				}
			}
			else
			{
				if (!targeted && children.length==0)
				{
					this.amount = Math.min(this.amount + this.rate * FlxG.elapsed, this.capacity);
					updateCounts();
				}
			}
		}
		
		public function updateCounts():void
		{
			var n:int = int(this.amount * 9 / this.capacity);
			if (n == 0 && this.amount > 0)
				n = 1;
						
			if (capDisplay != n)
			{
				FlxG.play(MenuState.SndBling);
				capDisplay = n;
				this.counters.play(colour + capDisplay.toString(), true);
				
				if (capDisplay == 9)
				{
					this.sprite.play(colour + "b", true);
					if (this.parent == null)
					{
						PlayState.nextlevel();
					}
					else
					{						
						FlxG.play(MenuState.SndBlocked,0.5);
					}

				}
			}
		}
		
		private function onClick():void
		{
			if (PlayState.mouseup)
			{
				PlayState.mouseup = false;
			}
			else
			{
				return;
			}
			if (PlayState.editmode)
			{
				PlayState.AddNew(this.location);
				return;
			}
			
			if (this.parent == null || this.targeted ||  this.parent.targeted || this.mergingdown || this.parent.mergingdown)			
				return;
			
			FlxG.play(MenuState.SndOpen,0.15);
				
			mergingdown = true;
			this.parent.targeted = true;
			FlxG.merges++;
			var index:int = this.parent.children.indexOf(this);	
			var conns:Vector.<Connector> = this.parent.connectionTo[index];
			for (var i:int = 0; i < conns.length; i++)
			{
				conns[i].play(this.colour.toString()+"f",true);
			}
			this.sprite.play(colour, true);
		}
		
		public function offsetPoint(p:Point):void
		{
			offset.x += p.x;
			offset.y += p.y;
			sprite.x += p.x;
			sprite.y += p.y;
			counters.x += p.x;
			counters.y += p.y;
			if (button != null)
			{
				button.x += p.x;
				button.y += p.y;
			}
			for (var i:int = 0; i < connectors.length; i++)
			{
				connectors[i].x += p.x;
				connectors[i].y += p.y;
			}
		}
		
	}

}